﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterSaldoUlangBulan>

@{
    ViewBag.Title = "Master Saldo Ulang Bulan";
    Layout = "~/Views/Shared/_Layout.cshtml";
}



@section HeadLibrary{
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE//plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE//plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE//plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE//plugins/toastr/toastr.min.css">
}

<style>
    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }
</style>

<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Saldo Ulang Bulan</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
            <button type="button" class="btn btn-success" data-toggle="modal" data-target="#modalAdd">
                <i class="fa fa-plus-circle fa"></i>  Tambah Data
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <table id="dataMasterSaldoUlangBulan" class="table table-bordered table-striped table-hover" role="grid" aria-describedby="dataMasterSaldoUlangBulan_info">
            <thead>
                <tr>
                    <th>
                        @Html.DisplayName("ID Saldo Ulang Bulan")
                    </th>
                    <th>
                        @Html.DisplayName("Jumlah Cuti Per Bulan")
                    </th>
                    <th>
                        @Html.DisplayName("Action")
                    </th>

                </tr>
            </thead>
            <tbody>
                <tr></tr>
                @*
                @foreach (var item in Model)
                {
                    <tr>
                        <td>
                            @Html.DisplayFor(modelItem => item.id_saldo_ulang_bulan)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.jml_cuti_per_bulan)
                        </td>
                        <td>
                            @*    @Html.ActionLink("Edit", "Edit", new { /* id=item.PrimaryKey */ }) |
                            @Html.ActionLink("Details", "Details", new { /* id=item.PrimaryKey */ }) |
                            @Html.ActionLink("Delete", "Delete", new { /* id=item.PrimaryKey */ })
                        </td>
                    </tr>
                }
                *@

            </tbody>
        </table>
    </div>
    <!-- /.card-body -->
</div>

<!-- /.modal -->
<div class="modal fade" id="modalAdd">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Input Data Saldo Ulang Bulan</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="id_saldo_ulang_bulan">ID Saldo Ulang Bulan</label>
                            <input type="text" class="form-control" id="id_saldo_ulang_bulan" placeholder="Masukkan ID Saldo Ulang Bulan">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="jml_cuti_per_bulan">Jumlah Cuti Per Bulan</label>
                            <input type="text" class="form-control" id="jml_cuti_per_bulan" placeholder="Masukkan Jumlah Cuti Per Bulan">
                            <span class="help-block"></span>
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="modal-footer justify-content-around">
                        <button type="button" id="btnAdd" class="btn btn-primary" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal -->
<!-- /.content -->
<!-- /.modal Edit start -->
<div class="modal fade" id="modalEdit">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Edit Data Saldo Ulang Bulan</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="edit_id_saldo_ulang_bulan">ID Saldo Ulang Bulan</label>
                            <input type="text" class="form-control" id="edit_id_saldo_ulang_bulan" required disabled>
                        </div>
                        <div class="form-group">
                            <label for="edit_jml_cuti_per_bulan">Jumlah Cuti Per Bulan</label>
                            <input type="text" class="form-control" id="edit_jml_cuti_per_bulan">
                            <span class="help-block"></span>
                        </div>

                    </div>
                    <!-- /.card-body -->

                    <div class="modal-footer justify-content-around">
                        <button type="button" id="btnUpdate" class="btn btn-primary" style="width:35%">Simpan</button>
                        <button type="button" class="btn btn-danger" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal edit end -->
<!-- /.content -->




@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>


}


@section AdditionalScript{
    <script>

        var rowId;
        var rowName;
        var masterSaldoUlangBulanTable;

        jQuery(document).ready(function ($) {


            masterSaldoUlangBulanTable = $("#dataMasterSaldoUlangBulan").DataTable({

                "responsive": true,
                "autoWidth": false,

                "ajax": {
                    "url": '@Url.Content("~/MasterSaldoUlangBulan/GetDatatableAllSaldo")',
                    "type": "POST",
                    "datatype": "JSON"
                },
                "columns": [
                    { "data": "id_saldo_ulang_bulan", "name": "id_saldo_ulang_bulan" },
                    { "data": "jml_cuti_per_bulan", "name": "jml_cuti_per_bulan" },
                    {
                        data: null, render: function (data, type, row) {
                            //return '<button type="button" data-toggle="modal" data-target="#modalEdit" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="editSaldoUlangBulan(\'' + data.id_saldo_ulang_bulan + '\')"><i class="icon-edit"></i></button>    <button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteSaldoUlangBulan(\'' + data.id_saldo_ulang_bulan + '\')"><i class="feather icon-trash"></i></button>'
                            return '<button type="button" data-toggle="modal" data-target="#modalEdit" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="editSaldoUlangBulan(\'' + data.id_saldo_ulang_bulan + '\')"><i class="fas fa-edit"></i></button>    <button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteSaldoUlangBulan(\'' + data.id_saldo_ulang_bulan + '\')"><i class="fa fa-trash-alt"></i></button>'

                        }

                    },
                    //{ "data": "created_by", "name": "created_by", "visible": false },
                    //{ "data": "created_date", "name": "created_date", "visible": false },
                    //{ "data": "changed_by", "name": "changed_by", "visible": false },
                    //{ "data": "changed_date", "name": "changed_date", "visible": false },
                ],

            });
        });


        //$(function () {
        //    $("#dataMasterKaryawan").DataTable({
        //        "responsive": true,
        //        "autoWidth": false,
        //    });
        //});

        $('#btnAdd').on('click', function () {
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()
            var validate = true;
            if ($("#id_saldo_ulang_bulan").val() == "" || !$("#id_saldo_ulang_bulan").val().replace(/\s/g, '').length) {
                //$('#id_saldo_ulang_bulan').parent().addClass('has-error');
                $('#id_saldo_ulang_bulan').next().text('ID Saldo Ulang Bulan harus diisi');
                validate = false;
            }

            if ($("#jml_cuti_per_bulan").val() == "" || !$("#jml_cuti_per_bulan").val().replace(/\s/g, '').length) {
                //$('#jml_cuti_per_bulan').parent().addClass('has-error');
                $('#jml_cuti_per_bulan').next().text('Jumlah Cuti Per Bulan harus diisi');
                validate = false;
            }

            if (!validate) return;
            $.ajax({
                    url: '@Url.Action("Create")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_saldo_ulang_bulan": $('#id_saldo_ulang_bulan').val(),
                        "jml_cuti_per_bulan": $('#jml_cuti_per_bulan').val(),

                        //"created_by": $('#created_by').val(),
                        //"created_date": $('#created_date').val(),
                        //"changed_by": $('#changed_by').val(),
                        //"changed_date": $('#changed_date').val()
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modalAdd').modal('hide');
                            masterSaldoUlangBulanTable.ajax.reload();
                            //masterKaryawanTable.clear().draw();
                            return toastr.success('Data berhasil ditambahkan.', 'Success!', { "timeOut": 5000 });
                        } else {
                            toastr.warning("Gagal menambahkan data.", "Sorry!", { "timeOut": 5000 });
                            //return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }

                });
        });

        $('#btnUpdate').on('click', function () {
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()
            var validate = true;

            if ($("#edit_jml_cuti_per_bulan").val() == "" || !$("#edit_jml_cuti_per_bulan").val().replace(/\s/g, '').length) {
               // $('#edit_jml_cuti_per_bulan').parent().addClass('has-error');
                $('#edit_jml_cuti_per_bulan').next().text('Jumlah Cuti Per Bulan harus diisi');
                validate = false;
            }

            if (!validate) return;
            $.ajax({
                    url: '@Url.Action("Update")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_saldo_ulang_bulan": $('#edit_id_saldo_ulang_bulan').val(),
                        "jml_cuti_per_bulan": $('#edit_jml_cuti_per_bulan').val(),

                        //"created_by": $('#edit_created_by').val(),
                        //"created_date": $('#edit_created_date').val(),
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modalEdit').modal('hide');
                            masterSaldoUlangBulanTable.ajax.reload();
                            //masterKaryawanTable.clear().draw();
                            return toastr.success('Data berhasil diperbarui.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning('Data gagal diperbarui.', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        });

        function editSaldoUlangBulan(id_saldo_ulang_bulan) {
            $.ajax({
                url: '@Url.Content("~/MasterSaldoUlangBulan/GetDataByIDSaldo")' + "/" + id_saldo_ulang_bulan,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#edit_id_saldo_ulang_bulan').val(result.response[0].id_saldo_ulang_bulan);
                            $('#edit_jml_cuti_per_bulan').val(result.response[0].jml_cuti_per_bulan).trigger('change');

                            //$('#edit_created_by').val(result.response[0].created_by);
                            //$('#edit_created_date').val(result.response[0].created_date);
                            //$('#edit_changed_by').val(result.response[0].changed_by);
                            //$('#edit_changed_date').val(result.response[0].changed_date);
                            $('#modalEdit').modal('show');
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }
        function deleteSaldoUlangBulan(id_saldo_ulang_bulan) {
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    return fetch('@Url.Action("DeleteSaldoUlangBulan")' + "/" + id_saldo_ulang_bulan, {
                        method: 'POST'
                    }).then(response => {
                        if (!response.ok) {
                            return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                        }
                        return response.json();
                    }).then(result => {
                        if (result.metaData.code === '200') {
                            masterSaldoUlangBulanTable.ajax.reload();
                            return toastr.success('Saldo has been deleted.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
    </script>
}